import { NgModule, Optional, SkipSelf } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { Ng2WigComponent } from './ng2wig.component';
import { Ng2WigToolbarService } from './ng2wig-toolbar.service';
import { Ng2WigConfig } from './ng2wig-config';
var Ng2WigModule = (function () {
    /**
     * @param {?} parentModule
     */
    function Ng2WigModule(parentModule) {
        if (parentModule) {
            throw new Error('Ng2WigModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @param {?} config
     * @return {?}
     */
    Ng2WigModule.forRoot = function (config) {
        return {
            ngModule: Ng2WigModule,
            providers: [
                { provide: Ng2WigConfig, useValue: config }
            ]
        };
    };
    return Ng2WigModule;
}());
export { Ng2WigModule };
Ng2WigModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    Ng2WigComponent
                ],
                imports: [
                    CommonModule,
                    FormsModule
                ],
                providers: [Ng2WigToolbarService],
                bootstrap: [Ng2WigComponent],
                exports: [Ng2WigComponent]
            },] },
];
/**
 * @nocollapse
 */
Ng2WigModule.ctorParameters = function () { return [
    { type: Ng2WigModule, decorators: [{ type: Optional }, { type: SkipSelf },] },
]; };
function Ng2WigModule_tsickle_Closure_declarations() {
    /** @type {?} */
    Ng2WigModule.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    Ng2WigModule.ctorParameters;
}
